QCPAxisRect Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Functions | Protected Functions
QCPAxisRect Class Reference

Holds multiple axes and arranges them in a rectangular shape. More...

Inheritance diagram for QCPAxisRect:

## Public Functions
| QCPAxisRect (QCustomPlot *parentPlot, bool setupDefaultAxes=true)
QPixmap | background () const
QBrush | backgroundBrush () const
bool | backgroundScaled () const
Qt::AspectRatioMode | backgroundScaledMode () const
Qt::Orientations | rangeDrag () const
Qt::Orientations | rangeZoom () const
QCPAxis * | rangeDragAxis (Qt::Orientation orientation)
QCPAxis * | rangeZoomAxis (Qt::Orientation orientation)
QList< QCPAxis * > | rangeDragAxes (Qt::Orientation orientation)
QList< QCPAxis * > | rangeZoomAxes (Qt::Orientation orientation)
double | rangeZoomFactor (Qt::Orientation orientation)
void | setBackground (const QPixmap &pm)
void | setBackground (const QPixmap &pm, bool scaled, Qt::AspectRatioMode mode=Qt::KeepAspectRatioByExpanding)
void | setBackground (const QBrush &brush)
void | setBackgroundScaled (bool scaled)
void | setBackgroundScaledMode (Qt::AspectRatioMode mode)
void | setRangeDrag (Qt::Orientations orientations)
void | setRangeZoom (Qt::Orientations orientations)
void | setRangeDragAxes (QCPAxis *horizontal, QCPAxis *vertical)
void | setRangeDragAxes (QList< QCPAxis * > axes)
void | setRangeDragAxes (QList< QCPAxis * > horizontal, QList< QCPAxis * > vertical)
void | setRangeZoomAxes (QCPAxis *horizontal, QCPAxis *vertical)
void | setRangeZoomAxes (QList< QCPAxis * > axes)
void | setRangeZoomAxes (QList< QCPAxis * > horizontal, QList< QCPAxis * > vertical)
void | setRangeZoomFactor (double horizontalFactor, double verticalFactor)
void | setRangeZoomFactor (double factor)
int | axisCount (QCPAxis::AxisType type) const
QCPAxis * | axis (QCPAxis::AxisType type, int index=0) const
QList< QCPAxis * > | axes (QCPAxis::AxisTypes types) const
QList< QCPAxis * > | axes () const
QCPAxis * | addAxis (QCPAxis::AxisType type, QCPAxis *axis=nullptr)
QList< QCPAxis * > | addAxes (QCPAxis::AxisTypes types)
bool | removeAxis (QCPAxis *axis)
QCPLayoutInset * | insetLayout () const
void | zoom (const QRectF &pixelRect)
void | zoom (const QRectF &pixelRect, const QList< QCPAxis * > &affectedAxes)
void | setupFullAxesBox (bool connectRanges=false)
QList< QCPAbstractPlottable * > | plottables () const
QList< QCPGraph * > | graphs () const
QList< QCPAbstractItem * > | items () const
int | left () const
int | right () const
int | top () const
int | bottom () const
int | width () const
int | height () const
QSize | size () const
QPoint | topLeft () const
QPoint | topRight () const
QPoint | bottomLeft () const
QPoint | bottomRight () const
QPoint | center () const
virtual void | update (UpdatePhase phase)
virtual QList< QCPLayoutElement * > | elements (bool recursive) const
Public Functions inherited from QCPLayoutElement
| QCPLayoutElement (QCustomPlot *parentPlot=nullptr)
QCPLayout * | layout () const
QRect | rect () const
QRect | outerRect () const
QMargins | margins () const
QMargins | minimumMargins () const
QCP::MarginSides | autoMargins () const
QSize | minimumSize () const
QSize | maximumSize () const
SizeConstraintRect | sizeConstraintRect () const
QCPMarginGroup * | marginGroup (QCP::MarginSide side) const
QHash< QCP::MarginSide, QCPMarginGroup * > | marginGroups () const
void | setOuterRect (const QRect &rect)
void | setMargins (const QMargins &margins)
void | setMinimumMargins (const QMargins &margins)
void | setAutoMargins (QCP::MarginSides sides)
void | setMinimumSize (const QSize &size)
void | setMinimumSize (int width, int height)
void | setMaximumSize (const QSize &size)
void | setMaximumSize (int width, int height)
void | setSizeConstraintRect (SizeConstraintRect constraintRect)
void | setMarginGroup (QCP::MarginSides sides, QCPMarginGroup *group)
virtual QSize | minimumOuterSizeHint () const
virtual QSize | maximumOuterSizeHint () const
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=nullptr)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Protected Functions
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | draw (QCPPainter *painter)
virtual int | calculateAutoMargin (QCP::MarginSide side)
virtual void | layoutChanged ()
virtual void | mousePressEvent (QMouseEvent *event, const QVariant &details)
virtual void | mouseMoveEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseReleaseEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | wheelEvent (QWheelEvent *event)
void | drawBackground (QCPPainter *painter)
void | updateAxesOffset (QCPAxis::AxisType type)
Protected Functions inherited from QCPLayoutElement
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
Protected Functions inherited from QCPLayerable
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
virtual void | mouseDoubleClickEvent (QMouseEvent *event, const QVariant &details)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Additional Inherited Members
Public Types inherited from QCPLayoutElement
enum | UpdatePhase
enum | SizeConstraintRect
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Detailed Description

Holds multiple axes and arranges them in a rectangular shape.

This class represents an axis rect, a rectangular area that is bounded on all sides with an arbitrary number of axes.

Initially QCustomPlot has one axis rect, accessible via QCustomPlot::axisRect(). However, the layout system allows to have multiple axis rects, e.g. arranged in a grid layout (QCustomPlot::plotLayout).

By default, QCPAxisRect comes with four axes, at bottom, top, left and right. They can be accessed via axis by providing the respective axis type (QCPAxis::AxisType) and index. If you need all axes in the axis rect, use axes. The top and right axes are set to be invisible initially (QCPAxis::setVisible). To add more axes to a side, use addAxis or addAxes. To remove an axis, use removeAxis.

The axis rect layerable itself only draws a background pixmap or color, if specified (setBackground). It is placed on the "background" layer initially (see QCPLayer for an explanation of the QCustomPlot layer system). The axes that are held by the axis rect can be placed on other layers, independently of the axis rect.

Every axis rect has a child layout of type QCPLayoutInset. It is accessible via insetLayout and can be used to have other layout elements (or even other layouts with multiple elements) hovering inside the axis rect.

If an axis rect is clicked and dragged, it processes this by moving certain axis ranges. The behaviour can be controlled with setRangeDrag and setRangeDragAxes. If the mouse wheel is scrolled while the cursor is on the axis rect, certain axes are scaled. This is controllable via setRangeZoom, setRangeZoomAxes and setRangeZoomFactor. These interactions are only enabled if QCustomPlot::setInteractions contains QCP::iRangeDrag and QCP::iRangeZoom.

Overview of the spacings and paddings that define the geometry of an axis. The dashed line on the far left indicates the viewport/widget border.

## Constructor & Destructor Documentation

## ◆ QCPAxisRect()

QCPAxisRect::QCPAxisRect | ( | QCustomPlot * | parentPlot,
|  | bool | setupDefaultAxes = true )
| explicit

Creates a QCPAxisRect instance and sets default values. An axis is added for each of the four sides, the top and right axes are set invisible initially.

## Member Function Documentation

## ◆ rangeDragAxis()

QCPAxis * QCPAxisRect::rangeDragAxis | ( | Qt::Orientation | orientation | ) |

Returns the range drag axis of the orientation provided. If multiple axes were set, returns the first one (use rangeDragAxes to retrieve a list with all set axes).

See also
  setRangeDragAxes

## ◆ rangeZoomAxis()

QCPAxis * QCPAxisRect::rangeZoomAxis | ( | Qt::Orientation | orientation | ) |

Returns the range zoom axis of the orientation provided. If multiple axes were set, returns the first one (use rangeZoomAxes to retrieve a list with all set axes).

See also
  setRangeZoomAxes

## ◆ rangeDragAxes()

QList< QCPAxis * > QCPAxisRect::rangeDragAxes | ( | Qt::Orientation | orientation | ) |

Returns all range drag axes of the orientation provided.

See also
  rangeZoomAxis, setRangeZoomAxes

## ◆ rangeZoomAxes()

QList< QCPAxis * > QCPAxisRect::rangeZoomAxes | ( | Qt::Orientation | orientation | ) |

Returns all range zoom axes of the orientation provided.

See also
  rangeDragAxis, setRangeDragAxes

## ◆ rangeZoomFactor()

double QCPAxisRect::rangeZoomFactor | ( | Qt::Orientation | orientation | ) |

Returns the range zoom factor of the orientation provided.

See also
  setRangeZoomFactor

## ◆ setBackground() [1/3]

void QCPAxisRect::setBackground | ( | const QPixmap & | pm | ) |

Sets pm as the axis background pixmap. The axis background pixmap will be drawn inside the axis rect. Since axis rects place themselves on the "background" layer by default, the axis rect backgrounds are usually drawn below everything else.

For cases where the provided pixmap doesn't have the same size as the axis rect, scaling can be enabled with setBackgroundScaled and the scaling mode (i.e. whether and how the aspect ratio is preserved) can be set with setBackgroundScaledMode. To set all these options in one call, consider using the overloaded version of this function.

Below the pixmap, the axis rect may be optionally filled with a brush, if specified with setBackground(const QBrush &brush).

See also
  setBackgroundScaled, setBackgroundScaledMode, setBackground(const QBrush &brush)

## ◆ setBackground() [2/3]

void QCPAxisRect::setBackground | ( | const QPixmap & | pm,
|  | bool | scaled,
|  | Qt::AspectRatioMode | mode = Qt::KeepAspectRatioByExpanding )

This is an overloaded function.
Allows setting the background pixmap of the axis rect, whether it shall be scaled and how it shall be scaled in one call.

See also
  setBackground(const QPixmap &pm), setBackgroundScaled, setBackgroundScaledMode

## ◆ setBackground() [3/3]

void QCPAxisRect::setBackground | ( | const QBrush & | brush | ) |

This is an overloaded function.
Sets brush as the background brush. The axis rect background will be filled with this brush. Since axis rects place themselves on the "background" layer by default, the axis rect backgrounds are usually drawn below everything else.

The brush will be drawn before (under) any background pixmap, which may be specified with setBackground(const QPixmap &pm).

To disable drawing of a background brush, set brush to Qt::NoBrush.

See also
  setBackground(const QPixmap &pm)

## ◆ setBackgroundScaled()

void QCPAxisRect::setBackgroundScaled | ( | bool | scaled | ) |

Sets whether the axis background pixmap shall be scaled to fit the axis rect or not. If scaled is set to true, you may control whether and how the aspect ratio of the original pixmap is preserved with setBackgroundScaledMode.

Note that the scaled version of the original pixmap is buffered, so there is no performance penalty on replots. (Except when the axis rect dimensions are changed continuously.)

See also
  setBackground, setBackgroundScaledMode

## ◆ setBackgroundScaledMode()

void QCPAxisRect::setBackgroundScaledMode | ( | Qt::AspectRatioMode | mode | ) |

If scaling of the axis background pixmap is enabled (setBackgroundScaled), use this function to define whether and how the aspect ratio of the original pixmap passed to setBackground is preserved.

See also
  setBackground, setBackgroundScaled

## ◆ setRangeDrag()

void QCPAxisRect::setRangeDrag | ( | Qt::Orientations | orientations | ) |

Sets which axis orientation may be range dragged by the user with mouse interaction. What orientation corresponds to which specific axis can be set with setRangeDragAxes(QCPAxis *horizontal, QCPAxis *vertical). By default, the horizontal axis is the bottom axis (xAxis) and the vertical axis is the left axis (yAxis).

To disable range dragging entirely, pass `nullptr` as orientations or remove QCP::iRangeDrag from QCustomPlot::setInteractions. To enable range dragging for both directions, pass Qt::Horizontal | Qt::Vertical as orientations.

In addition to setting orientations to a non-zero value, make sure QCustomPlot::setInteractions contains QCP::iRangeDrag to enable the range dragging interaction.

See also
  setRangeZoom, setRangeDragAxes, QCustomPlot::setNoAntialiasingOnDrag

## ◆ setRangeZoom()

void QCPAxisRect::setRangeZoom | ( | Qt::Orientations | orientations | ) |

Sets which axis orientation may be zoomed by the user with the mouse wheel. What orientation corresponds to which specific axis can be set with setRangeZoomAxes(QCPAxis *horizontal, QCPAxis *vertical). By default, the horizontal axis is the bottom axis (xAxis) and the vertical axis is the left axis (yAxis).

To disable range zooming entirely, pass `nullptr` as orientations or remove QCP::iRangeZoom from QCustomPlot::setInteractions. To enable range zooming for both directions, pass Qt::Horizontal | Qt::Vertical as orientations.

In addition to setting orientations to a non-zero value, make sure QCustomPlot::setInteractions contains QCP::iRangeZoom to enable the range zooming interaction.

See also
  setRangeZoomFactor, setRangeZoomAxes, setRangeDrag

## ◆ setRangeDragAxes() [1/3]

void QCPAxisRect::setRangeDragAxes | ( | QCPAxis * | horizontal,
|  | QCPAxis * | vertical )

This is an overloaded function.
Sets the axes whose range will be dragged when setRangeDrag enables mouse range dragging on the QCustomPlot widget. Pass `nullptr` if no axis shall be dragged in the respective orientation.

Use the overload taking a list of axes, if multiple axes (more than one per orientation) shall react to dragging interactions.

See also
  setRangeZoomAxes

## ◆ setRangeDragAxes() [2/3]

void QCPAxisRect::setRangeDragAxes | ( | QList< QCPAxis * > | axes | ) |

This is an overloaded function.
This method allows to set up multiple axes to react to horizontal and vertical dragging. The drag orientation that the respective axis will react to is deduced from its orientation (QCPAxis::orientation).

In the unusual case that you wish to e.g. drag a vertically oriented axis with a horizontal drag motion, use the overload taking two separate lists for horizontal and vertical dragging.

## ◆ setRangeDragAxes() [3/3]

void QCPAxisRect::setRangeDragAxes | ( | QList< QCPAxis * > | horizontal,
|  | QList< QCPAxis * > | vertical )

This is an overloaded function.
This method allows to set multiple axes up to react to horizontal and vertical dragging, and define specifically which axis reacts to which drag orientation (irrespective of the axis orientation).

## ◆ setRangeZoomAxes() [1/3]

void QCPAxisRect::setRangeZoomAxes | ( | QCPAxis * | horizontal,
|  | QCPAxis * | vertical )

Sets the axes whose range will be zoomed when setRangeZoom enables mouse wheel zooming on the QCustomPlot widget. Pass `nullptr` if no axis shall be zoomed in the respective orientation.

The two axes can be zoomed with different strengths, when different factors are passed to setRangeZoomFactor(double horizontalFactor, double verticalFactor).

Use the overload taking a list of axes, if multiple axes (more than one per orientation) shall react to zooming interactions.

See also
  setRangeDragAxes

## ◆ setRangeZoomAxes() [2/3]

void QCPAxisRect::setRangeZoomAxes | ( | QList< QCPAxis * > | axes | ) |

This is an overloaded function.
This method allows to set up multiple axes to react to horizontal and vertical range zooming. The zoom orientation that the respective axis will react to is deduced from its orientation (QCPAxis::orientation).

In the unusual case that you wish to e.g. zoom a vertically oriented axis with a horizontal zoom interaction, use the overload taking two separate lists for horizontal and vertical zooming.

## ◆ setRangeZoomAxes() [3/3]

void QCPAxisRect::setRangeZoomAxes | ( | QList< QCPAxis * > | horizontal,
|  | QList< QCPAxis * > | vertical )

This is an overloaded function.
This method allows to set multiple axes up to react to horizontal and vertical zooming, and define specifically which axis reacts to which zoom orientation (irrespective of the axis orientation).

## ◆ setRangeZoomFactor() [1/2]

void QCPAxisRect::setRangeZoomFactor | ( | double | horizontalFactor,
|  | double | verticalFactor )

Sets how strong one rotation step of the mouse wheel zooms, when range zoom was activated with setRangeZoom. The two parameters horizontalFactor and verticalFactor provide a way to let the horizontal axis zoom at different rates than the vertical axis. Which axis is horizontal and which is vertical, can be set with setRangeZoomAxes.

When the zoom factor is greater than one, scrolling the mouse wheel backwards (towards the user) will zoom in (make the currently visible range smaller). For zoom factors smaller than one, the same scrolling direction will zoom out.

## ◆ setRangeZoomFactor() [2/2]

void QCPAxisRect::setRangeZoomFactor | ( | double | factor | ) |

This is an overloaded function.
Sets both the horizontal and vertical zoom factor.

## ◆ axisCount()

int QCPAxisRect::axisCount | ( | QCPAxis::AxisType | type | ) | const

Returns the number of axes on the axis rect side specified with type.

See also
  axis

## ◆ axis()

QCPAxis * QCPAxisRect::axis | ( | QCPAxis::AxisType | type,
|  | int | index = 0 ) const

Returns the axis with the given index on the axis rect side specified with type.

See also
  axisCount, axes

## ◆ axes() [1/2]

QList< QCPAxis * > QCPAxisRect::axes | ( | QCPAxis::AxisTypes | types | ) | const

Returns all axes on the axis rect sides specified with types.

types may be a single QCPAxis::AxisType or an or-combination, to get the axes of multiple sides.

See also
  axis

## ◆ axes() [2/2]

QList< QCPAxis * > QCPAxisRect::axes | ( |  | ) | const

This is an overloaded function.
Returns all axes of this axis rect.

## ◆ addAxis()

QCPAxis * QCPAxisRect::addAxis | ( | QCPAxis::AxisType | type,
|  | QCPAxis * | axis = nullptr )

Adds a new axis to the axis rect side specified with type, and returns it. If axis is 0, a new QCPAxis instance is created internally. QCustomPlot owns the returned axis, so if you want to remove an axis, use removeAxis instead of deleting it manually.

You may inject QCPAxis instances (or subclasses of QCPAxis) by setting axis to an axis that was previously created outside QCustomPlot. It is important to note that QCustomPlot takes ownership of the axis, so you may not delete it afterwards. Further, the axis must have been created with this axis rect as parent and with the same axis type as specified in type. If this is not the case, a debug output is generated, the axis is not added, and the method returns `nullptr`.

This method can not be used to move axis between axis rects. The same axis instance must not be added multiple times to the same or different axis rects.

If an axis rect side already contains one or more axes, the lower and upper endings of the new axis (QCPAxis::setLowerEnding, QCPAxis::setUpperEnding) are set to QCPLineEnding::esHalfBar.

See also
  addAxes, setupFullAxesBox

## ◆ addAxes()

QList< QCPAxis * > QCPAxisRect::addAxes | ( | QCPAxis::AxisTypes | types | ) |

Adds a new axis with addAxis to each axis rect side specified in types. This may be an or-combination of QCPAxis::AxisType, so axes can be added to multiple sides at once.

Returns a list of the added axes.

See also
  addAxis, setupFullAxesBox

## ◆ removeAxis()

bool QCPAxisRect::removeAxis | ( | QCPAxis * | axis | ) |

Removes the specified axis from the axis rect and deletes it.

Returns true on success, i.e. if axis was a valid axis in this axis rect.

See also
  addAxis

## ◆ insetLayout()

QCPLayoutInset * QCPAxisRect::insetLayout | ( |  | ) | const
| inline

Returns the inset layout of this axis rect. It can be used to place other layout elements (or even layouts with multiple other elements) inside/on top of an axis rect.

See also
  QCPLayoutInset

## ◆ zoom() [1/2]

void QCPAxisRect::zoom | ( | const QRectF & | pixelRect | ) |

Zooms in (or out) to the passed rectangular region pixelRect, given in pixel coordinates.

All axes of this axis rect will have their range zoomed accordingly. If you only wish to zoom specific axes, use the overloaded version of this method.

See also
  QCustomPlot::setSelectionRectMode

## ◆ zoom() [2/2]

void QCPAxisRect::zoom | ( | const QRectF & | pixelRect,
|  | const QList< QCPAxis * > & | affectedAxes )

This is an overloaded function.
Zooms in (or out) to the passed rectangular region pixelRect, given in pixel coordinates.

Only the axes passed in affectedAxes will have their ranges zoomed accordingly.

See also
  QCustomPlot::setSelectionRectMode

## ◆ setupFullAxesBox()

void QCPAxisRect::setupFullAxesBox | ( | bool | connectRanges = false | ) |

Convenience function to create an axis on each side that doesn't have any axes yet and set their visibility to true. Further, the top/right axes are assigned the following properties of the bottom/left axes:

- range (QCPAxis::setRange)
- range reversed (QCPAxis::setRangeReversed)
- scale type (QCPAxis::setScaleType)
- tick visibility (QCPAxis::setTicks)
- number format (QCPAxis::setNumberFormat)
- number precision (QCPAxis::setNumberPrecision)
- tick count of ticker (QCPAxisTicker::setTickCount)
- tick origin of ticker (QCPAxisTicker::setTickOrigin)

Tick label visibility (QCPAxis::setTickLabels) of the right and top axes are set to false.

If connectRanges is true, the rangeChanged signals of the bottom and left axes are connected to the QCPAxis::setRange slots of the top and right axes.

## ◆ plottables()

QList< QCPAbstractPlottable * > QCPAxisRect::plottables | ( |  | ) | const

Returns a list of all the plottables that are associated with this axis rect.

A plottable is considered associated with an axis rect if its key or value axis (or both) is in this axis rect.

See also
  graphs, items

## ◆ graphs()

QList< QCPGraph * > QCPAxisRect::graphs | ( |  | ) | const

Returns a list of all the graphs that are associated with this axis rect.

A graph is considered associated with an axis rect if its key or value axis (or both) is in this axis rect.

See also
  plottables, items

## ◆ items()

QList< QCPAbstractItem * > QCPAxisRect::items | ( |  | ) | const

Returns a list of all the items that are associated with this axis rect.

An item is considered associated with an axis rect if any of its positions has key or value axis set to an axis that is in this axis rect, or if any of its positions has QCPItemPosition::setAxisRect set to the axis rect, or if the clip axis rect (QCPAbstractItem::setClipAxisRect) is set to this axis rect.

See also
  plottables, graphs

## ◆ left()

int QCPAxisRect::left | ( |  | ) | const
| inline

Returns the pixel position of the left border of this axis rect. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ right()

int QCPAxisRect::right | ( |  | ) | const
| inline

Returns the pixel position of the right border of this axis rect. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ top()

int QCPAxisRect::top | ( |  | ) | const
| inline

Returns the pixel position of the top border of this axis rect. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ bottom()

int QCPAxisRect::bottom | ( |  | ) | const
| inline

Returns the pixel position of the bottom border of this axis rect. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ width()

int QCPAxisRect::width | ( |  | ) | const
| inline

Returns the pixel width of this axis rect. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ height()

int QCPAxisRect::height | ( |  | ) | const
| inline

Returns the pixel height of this axis rect. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ size()

QSize QCPAxisRect::size | ( |  | ) | const
| inline

Returns the pixel size of this axis rect. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ topLeft()

QPoint QCPAxisRect::topLeft | ( |  | ) | const
| inline

Returns the top left corner of this axis rect in pixels. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ topRight()

QPoint QCPAxisRect::topRight | ( |  | ) | const
| inline

Returns the top right corner of this axis rect in pixels. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ bottomLeft()

QPoint QCPAxisRect::bottomLeft | ( |  | ) | const
| inline

Returns the bottom left corner of this axis rect in pixels. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ bottomRight()

QPoint QCPAxisRect::bottomRight | ( |  | ) | const
| inline

Returns the bottom right corner of this axis rect in pixels. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ center()

QPoint QCPAxisRect::center | ( |  | ) | const
| inline

Returns the center of this axis rect in pixels. Margins are not taken into account here, so the returned value is with respect to the inner rect.

## ◆ update()

void QCPAxisRect::update | ( | UpdatePhase | phase | ) |
| virtual

This method is called automatically upon replot and doesn't need to be called by users of QCPAxisRect.

Calls the base class implementation to update the margins (see QCPLayoutElement::update), and finally passes the rect to the inset layout (insetLayout) and calls its QCPInsetLayout::update function.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPLayoutElement.

## ◆ elements()

QList< QCPLayoutElement * > QCPAxisRect::elements | ( | bool | recursive | ) | const
| virtual

Returns a list of all child elements in this layout element. If recursive is true, all sub-child elements are included in the list, too.

Warning
  There may be `nullptr` entries in the returned list. For example, QCPLayoutGrid may have empty cells which yield `nullptr` at the respective index.

Reimplemented from QCPLayoutElement.

## ◆ applyDefaultAntialiasingHint()

void QCPAxisRect::applyDefaultAntialiasingHint | ( | QCPPainter * | painter | ) | const
| protectedvirtual

This function applies the default antialiasing setting to the specified painter, using the function applyAntialiasingHint. It is the antialiasing state the painter is put in, when draw is called on the layerable. If the layerable has multiple entities whose antialiasing setting may be specified individually, this function should set the antialiasing state of the most prominent entity. In this case however, the draw function usually calls the specialized versions of this function before drawing each entity, effectively overriding the setting of the default antialiasing hint.

First example: QCPGraph has multiple entities that have an antialiasing setting: The graph line, fills and scatters. Those can be configured via QCPGraph::setAntialiased, QCPGraph::setAntialiasedFill and QCPGraph::setAntialiasedScatters. Consequently, there isn't only the QCPGraph::applyDefaultAntialiasingHint function (which corresponds to the graph line's antialiasing), but specialized ones like QCPGraph::applyFillAntialiasingHint and QCPGraph::applyScattersAntialiasingHint. So before drawing one of those entities, QCPGraph::draw calls the respective specialized applyAntialiasingHint function.

Second example: QCPItemLine consists only of a line so there is only one antialiasing setting which can be controlled with QCPItemLine::setAntialiased. (This function is inherited by all layerables. The specialized functions, as seen on QCPGraph, must be added explicitly to the respective layerable subclass.) Consequently it only has the normal QCPItemLine::applyDefaultAntialiasingHint. The QCPItemLine::draw function doesn't need to care about setting any antialiasing states, because the default antialiasing hint is already set on the painter when the draw function is called, and that's the state it wants to draw the line with.

Reimplemented from QCPLayoutElement.

## ◆ draw()

void QCPAxisRect::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

This function draws the layerable with the specified painter. It is only called by QCustomPlot, if the layerable is visible (setVisible).

Before this function is called, the painter's antialiasing state is set via applyDefaultAntialiasingHint, see the documentation there. Further, the clipping rectangle was set to clipRect.

Reimplemented from QCPLayoutElement.

## ◆ calculateAutoMargin()

int QCPAxisRect::calculateAutoMargin | ( | QCP::MarginSide | side | ) |
| protectedvirtual

Returns the margin size for this side. It is used if automatic margins is enabled for this side (see setAutoMargins). If a minimum margin was set with setMinimumMargins, the returned value will not be smaller than the specified minimum margin.

The default implementation just returns the respective manual margin (setMargins) or the minimum margin, whichever is larger.

Reimplemented from QCPLayoutElement.

## ◆ layoutChanged()

void QCPAxisRect::layoutChanged | ( |  | ) |
| protectedvirtual

Reacts to a change in layout to potentially set the convenience axis pointers QCustomPlot::xAxis, QCustomPlot::yAxis, etc. of the parent QCustomPlot to the respective axes of this axis rect. This is only done if the respective convenience pointer is currently zero and if there is no QCPAxisRect at position (0, 0) of the plot layout.

This automation makes it simpler to replace the main axis rect with a newly created one, without the need to manually reset the convenience pointers.

Reimplemented from QCPLayoutElement.

## ◆ mousePressEvent()

void QCPAxisRect::mousePressEvent | ( | QMouseEvent * | event,
|  | const QVariant & | details )
| protectedvirtual

Event handler for when a mouse button is pressed on the axis rect. If the left mouse button is pressed, the range dragging interaction is initialized (the actual range manipulation happens in the mouseMoveEvent).

The mDragging flag is set to true and some anchor points are set that are needed to determine the distance the mouse was dragged in the mouse move/release events later.

See also
  mouseMoveEvent, mouseReleaseEvent

Reimplemented from QCPLayerable.

## ◆ mouseMoveEvent()

void QCPAxisRect::mouseMoveEvent | ( | QMouseEvent * | event,
|  | const QPointF & | startPos )
| protectedvirtual

Event handler for when the mouse is moved on the axis rect. If range dragging was activated in a preceding mousePressEvent, the range is moved accordingly.

See also
  mousePressEvent, mouseReleaseEvent

Reimplemented from QCPLayerable.

## ◆ mouseReleaseEvent()

void QCPAxisRect::mouseReleaseEvent | ( | QMouseEvent * | event,
|  | const QPointF & | startPos )
| protectedvirtual

This event gets called when the user releases the mouse button, after this layerable has become the mouse grabber by accepting the preceding mousePressEvent.

The current pixel position of the cursor on the QCustomPlot widget is accessible via `event->pos()`. The parameter startPos indicates the position where the initial mousePressEvent occurred, that started the mouse interaction.

The default implementation does nothing.

See also
  mousePressEvent, mouseMoveEvent, mouseDoubleClickEvent, wheelEvent

Reimplemented from QCPLayerable.

## ◆ wheelEvent()

void QCPAxisRect::wheelEvent | ( | QWheelEvent * | event | ) |
| protectedvirtual

Event handler for mouse wheel events. If rangeZoom is Qt::Horizontal, Qt::Vertical or both, the ranges of the axes defined as rangeZoomHorzAxis and rangeZoomVertAxis are scaled. The center of the scaling operation is the current cursor position inside the axis rect. The scaling factor is dependent on the mouse wheel delta (which direction the wheel was rotated) to provide a natural zooming feel. The Strength of the zoom can be controlled via setRangeZoomFactor.

Note, that event->angleDelta() is usually +/-120 for single rotation steps. However, if the mouse wheel is turned rapidly, many steps may bunch up to one event, so the delta may then be multiples of 120. This is taken into account here, by calculating wheelSteps and using it as exponent of the range zoom factor. This takes care of the wheel direction automatically, by inverting the factor, when the wheel step is negative (f^-1 = 1/f).

Reimplemented from QCPLayerable.

## ◆ drawBackground()

void QCPAxisRect::drawBackground | ( | QCPPainter * | painter | ) |
| protected

Draws the background of this axis rect. It may consist of a background fill (a QBrush) and a pixmap.

If a brush was given via setBackground(const QBrush &brush), this function first draws an according filling inside the axis rect with the provided painter.

Then, if a pixmap was provided via setBackground, this function buffers the scaled version depending on setBackgroundScaled and setBackgroundScaledMode and then draws it inside the axis rect with the provided painter. The scaled version is buffered in mScaledBackgroundPixmap to prevent expensive rescaling at every redraw. It is only updated, when the axis rect has changed in a way that requires a rescale of the background pixmap (this is dependent on the setBackgroundScaledMode), or when a differend axis background pixmap was set.

See also
  setBackground, setBackgroundScaled, setBackgroundScaledMode

## ◆ updateAxesOffset()

void QCPAxisRect::updateAxesOffset | ( | QCPAxis::AxisType | type | ) |
| protected

This function makes sure multiple axes on the side specified with type don't collide, but are distributed according to their respective space requirement (QCPAxis::calculateMargin).

It does this by setting an appropriate offset (QCPAxis::setOffset) on all axes except the one with index zero.

This function is called by calculateAutoMargin.

The documentation for this class was generated from the following files:

- src/layoutelements/layoutelement-axisrect.h
- src/layoutelements/layoutelement-axisrect.cpp